"use strict";

function isNotValid(data) {
  return typeof data !== "string";
}

function hasQuestionMark(data) {
  return data.substring(0, 1) === "?";
}

/**
 * Converts a query string to an object of key value pairs.
 * @param {string} data
 * @return {object}
 */
module.exports = {
  parser(input) {
    if (isNotValid(input)) {
      return {};
    }

    let queryString = input.trim();

    if (hasQuestionMark(queryString)) {
      queryString = queryString.substring(1);
    }

    return queryString
      .split("&")
      .map(param => param.split("="))
      .reduce((acc, curr) => {
        return {
          ...acc,
          [curr[0]]: curr[1],
        };
      }, {});
  },
};
