import { parser } from "./index";

describe("parser", () => {
  it("should return an object with params", () => {
    const input = "?valueOne=one&valueTwo=two";
    const expectedResult = { valueOne: "one", valueTwo: "two" };
    expect(parser(input)).toEqual(expectedResult);
  });

  it("should return an empty object when no input is given", () => {
    expect(parser("")).toEqual({});
    expect(parser(null)).toEqual({});
    expect(parser(undefined)).toEqual({});
    expect(parser({})).toEqual({});
    expect(parser(1)).toEqual({});
    expect(parser(0)).toEqual({});
  });

  it("should return an empty object when no queries are present", () => {
    const input = "?";
    expect(parser(input)).toEqual({});
  });

  it("should handle query string with missing ?", () => {
    const input = "name=Jack&age=26";
    const expectedResult = { name: "Jack", age: "26" };
    expect(parser(input)).toEqual(expectedResult);
  });
});
